clear all; close all; clc;

load('SPA_FERRARI_312T.mat');
load('SPA_LEFT_POS.mat');
load('SPA_RIGHT_POS.mat');

j=1;
lapIndex = [1];
for i=2:length(Session_Lap_Count.Value)
    if Session_Lap_Count.Value(i) ~= Session_Lap_Count.Value(i-1)
        lapIndex = [lapIndex i];
        j = j+1;
    end
end

numLap = length(lapIndex)-1;



% LAP   м
%     50000 interpolation
dataNum = 50000;

StrSpd = Steering_Angle.Value(2:length(Steering_Angle.Value)) - Steering_Angle.Value(1:length(Steering_Angle.Value)-1);
StrSpd = [0,StrSpd]*0.05; % 20 Hz sampling

for i=2:length(lapIndex)
    x = [1:(lapIndex(i)-lapIndex(i-1))+1];
    xq = [1:(lapIndex(i)-lapIndex(i-1))/(dataNum-1):(lapIndex(i)-lapIndex(i-1))+1];
    
    v = Steering_Angle.Time(lapIndex(i-1):lapIndex(i));
    t(:,i-1) = interp1(x,v,xq);
    t(:,i-1) = t(:,i-1) - t(1,i-1);
    
    v = Brake_Pos.Value(lapIndex(i-1):lapIndex(i));
    BrkPos(:,i-1) = interp1(x,v,xq);
    
    v = Steering_Angle.Value(lapIndex(i-1):lapIndex(i));
    SteerAng(:,i-1) = interp1(x,v,xq);
    
    v = StrSpd(lapIndex(i-1):lapIndex(i));
    SteerSpd(:,i-1) = interp1(x,v,xq);
    
    v = Throttle_Pos.Value(lapIndex(i-1):lapIndex(i));
    ThrPos(:,i-1) = interp1(x,v,xq);
    
    v = Car_Coord_X.Value(lapIndex(i-1):lapIndex(i));
    CarX(:,i-1) = interp1(x,v,xq);
    
    v = Car_Coord_Y.Value(lapIndex(i-1):lapIndex(i));
    CarY(:,i-1) = interp1(x,v,xq);
    
    v = Car_Coord_Z.Value(lapIndex(i-1):lapIndex(i));
    CarZ(:,i-1) = interp1(x,v,xq);
    
    v = CG_Accel_Lateral.Value(lapIndex(i-1):lapIndex(i));
    GLat(:,i-1) = interp1(x,v,xq);
    
    v = CG_Accel_Longitudinal.Value(lapIndex(i-1):lapIndex(i));
    GLong(:,i-1) = interp1(x,v,xq);
    
    v = CG_Accel_Vertical.Value(lapIndex(i-1):lapIndex(i));
    GVer(:,i-1) = interp1(x,v,xq);
    
    v = Engine_RPM.Value(lapIndex(i-1):lapIndex(i));
    EngRpm(:,i-1) = interp1(x,v,xq);
    
    v = Corr_Dist.Value(lapIndex(i-1):lapIndex(i));
    CorrDist(:,i-1) = interp1(x,v,xq);
    CorrDist(:,i-1) = CorrDist(:,i-1)-CorrDist(1,i-1);
    
    v = Corr_Speed.Value(lapIndex(i-1):lapIndex(i));
    CorrSpd(:,i-1) = interp1(x,v,xq);
end


%----------------------------------------%
% ǥ ġȯ
%----------------------------------------%

% Track map ġ  ǥ  0 ġȯ
Xoffset = (trackRX(1) + trackLX(1)) / 2;
Yoffset = (trackRY(1) + trackLY(1)) / 2;
Zoffset = (trackRZ(1) + trackLZ(1)) / 2;

trackLX = trackLX - Xoffset;
trackLY = trackLY - Yoffset;
trackLZ = trackLZ - Zoffset;

trackRX = trackRX - Xoffset;
trackRY = trackRY - Yoffset;
trackRZ = trackRZ - Zoffset;

% ġ 0 ġȯ
CarX = CarX - ones(size(CarX,1),size(CarX,2))*Xoffset;
CarY = CarY - ones(size(CarY,1),size(CarY,2))*Yoffset;
CarZ = CarZ - ones(size(CarZ,1),size(CarZ,2))*Zoffset;


%    η ǥϱ    ֺ͸ 

% ð⿡  Ŷ ٱ
% ݽð⿡  Ŷ ٱ
% ̼  (x,y)  ϸ
% (-y,x) =  / (y,-x) = 

% ̼  
CarDX = CarX(2:dataNum,:) - CarX(1:dataNum-1,:);
CarDX = [CarDX(1,:);CarDX];
CarDY = CarY(2:dataNum,:) - CarY(1:dataNum-1,:);
CarDY = [CarDY(1,:);CarDY];
CarDZ = CarZ(2:dataNum,:) - CarZ(1:dataNum-1,:);
CarDZ = [CarDZ(1,:);CarDZ];

% Ⱦӵ  η ǥϱ    ֺ͸ 
CarDXcon = CarDY;
CarDYcon = -CarDX;

% ֹ  ũ⸦ normalizeϱ  Ʒ ڵ .
CarDirNorm = zeros(dataNum,2,numLap);
for i=[1:size(CarDXcon,2)]
    CarDirNorm(:,:,i) = [CarDXcon(:,i) CarDYcon(:,i)]./(sqrt(CarDXcon(:,i).^2 + CarDYcon(:,i).^2)*ones(1,2)); 
end
CarDirNorm = permute(CarDirNorm,[1,3,2]);

% normalize   Ҵ
CarDXcon = CarDirNorm(:,:,1);
CarDYcon = CarDirNorm(:,:,2);


% Ⱦӵ  󸶳 Ǯ ׷ ǥ ΰ:
%  Ⱦӵ 2~3G ƽε ǥ m  ; Ǵϱ ׳ ϸ ǥð ȳ
GFactor = 30;
StrFactor = 10;

% Ⱦӵ  ǿ ؼ ǥ
GLatModX = CarX + GFactor*GLat.*CarDXcon;
GLatModY = CarY + GFactor*GLat.*CarDYcon;

% Ƽ ޱ۵  ǿ ؼ ǥ
StrAngModX = CarX + SteerAng.*(-CarDXcon)/StrFactor;
StrAngModY = CarY + SteerAng.*(-CarDYcon)/StrFactor;

% Throttle , Brake  ؼ ϳ  ǥ
ThrNBrk = ThrPos - BrkPos;


% ּ ð ɸ  ãƳ
[BestTime, BestLap] = min(t(length(t),:));

% Total G
GAll = sqrt(GLat.^2 + GLong.^2 + GVer.^2);

% LAP     ǥ
BrkPosMean = mean(BrkPos');
BrkPosStd = std(BrkPos');
ThrPosMean = mean(ThrPos');
ThrPosStd = std(ThrPos');
SteerAngMean = mean(SteerAng');
SteerAngStd = std(SteerAng');

% ׷  min/max   ü min/max 
Xmin = min(min(CarX));
Ymin = min(min(CarY));
Zmin = min(min(CarZ));
posMin = min([Xmin Ymin Zmin]);

Xmax = max(max(CarX));
Ymax = max(max(CarY));
Zmax = max(max(CarZ));
posMax = max([Xmax Ymax Zmax]);

boundary = posMax - posMin + 100;

AxisBound = Xmax - Xmin;
diff = boundary - AxisBound;
Xmax = Xmax + diff/2;
Xmin = Xmin - diff/2;

AxisBound = Ymax - Ymin;
diff = boundary - AxisBound;
Ymax = Ymax + diff/2;
Ymin = Ymin - diff/2;

AxisBound = Zmax - Zmin;
diff = boundary - AxisBound;
Zmax = Zmax + diff/2;
Zmin = Zmin - diff/2;


x0=500;
y0=10;
width=700;
height=700;

trackColor = [0.5 0.5 0.5];


% ⺻ 
figure; 
subplot(3,1,1);
plot(CorrDist,SteerAng,'b'); grid on; hold on;
plot(CorrDist(:,BestLap),SteerAng(:,BestLap),'r','LineWidth',2); 
title('Steering Angle'); xlabel('Distance (m)');ylabel('Angle (deg)');

subplot(3,1,2);
plot(t,CorrDist,'b'); grid on; hold on;
plot(t(:,BestLap),CorrDist(:,BestLap),'r','LineWidth',2); 
title('Distance'); xlabel('Time (s)');ylabel('Distance (m)');

subplot(3,1,3);
plot(CorrDist,CorrSpd,'b');grid on; hold on;
plot(CorrDist(:,BestLap),CorrSpd(:,BestLap),'r','LineWidth',2);
title('Speed'); xlabel('Distance (m)');ylabel('Speed (km/h)');



% ̺ 
figure; grid on; hold on;
plot3(CarX,CarY,CarZ,'b');
plot3(trackLX,trackLY,trackLZ,'color',trackColor,'linewidth',1); % Ʈ 
plot3(trackRX,trackRY,trackRZ,'color',trackColor,'linewidth',1); % Ʈ 
plot3(CarX(:,BestLap),CarY(:,BestLap),CarZ(:,BestLap),'r','LineWidth',3);
plot([trackLX(1) trackRX(1)],[trackLY(1) trackRY(1)],'black','LineWidth',2); % ŸƮ
title('Driving Line'); xlim([Xmin Xmax]); ylim([Ymin Ymax]); zlim([Zmin Zmax]);
set(gcf,'units','points','position',[x0,y0,width,height]);

% Ƽ 
figure; grid on; hold on;
plot3(CarX,CarY,SteerAng,'b'); 
plot(CarX,CarY,'black'); 
plot(trackLX,trackLY,'color',trackColor,'linewidth',1); % Ʈ 
plot(trackRX,trackRY,'color',trackColor,'linewidth',1); % Ʈ 
plot3(CarX(:,BestLap),CarY(:,BestLap),SteerAng(:,BestLap),'r','LineWidth',2);
title('Steering Angle'); zlabel('Angle (deg)'); xlim([Xmin Xmax]); ylim([Ymin Ymax]);
set(gcf,'units','points','position',[x0,y0,width,height]);


% Best Lap ӵ ׷
figure; grid on; hold on;
plot(trackLX,trackLY,'color',trackColor,'linewidth',1); % Ʈ 
plot(trackRX,trackRY,'color',trackColor,'linewidth',1); % Ʈ 
plot(CarX(:,BestLap),CarY(:,BestLap),'black','LineWidth',2); % ̺ 
plot(GLatModX(:,BestLap),GLatModY(:,BestLap),'b'); % Ⱦӵ
plot3(CarX(:,BestLap),CarY(:,BestLap),GLong(:,BestLap),'r'); % ӵ
plot3(GLatModX(:,BestLap),GLatModY(:,BestLap),GLong(:,BestLap),'color',[0 0.8 0],'LineWidth',1); % Ⱦ+ӵ ͷ
plot([trackLX(1) trackRX(1)],[trackLY(1) trackRY(1)],'black','LineWidth',2); % ŸƮ
for i=[1:10:length(CarX)]
    plot3([CarX(i,BestLap) GLatModX(i,BestLap)],[CarY(i,BestLap) GLatModY(i,BestLap)], [0 GLong(i,BestLap)],'color',[0 0.8 0],'LineWidth',1); % Ⱦ+ӵ  
end
title('Total G (Best Lap)'); zlabel('Accelaration (G)');
xlim([Xmin Xmax]); ylim([Ymin Ymax]); zlim([Zmin/GFactor Zmax/GFactor]);
set(gcf,'units','points','position',[x0,y0,width,height]);



% G  е (׷)
X = [GLat(:), GLong(:)];
edgeDense = [-3:6/(500-1):3];
AccMap = hist3(X,{edgeDense edgeDense});


figure;
mesh(edgeDense,edgeDense,AccMap); grid on;
xlim([-3 3]); ylim([-3 3]); title('G-Force density'); xlabel('G_{Lat}'); ylabel('G_{Long}');
set(gcf,'units','points','position',[x0,y0,400,400]);

figure;
mesh(edgeDense,edgeDense,log(AccMap+1)); grid on;
xlim([-3 3]); ylim([-3 3]); title('G-Force density (log)'); xlabel('G_{Lat}'); ylabel('G_{Long}');
set(gcf,'units','points','position',[x0,y0,400,400]);